grpbrwsr.cls

!GrepBrowser methods !
  
open

    | ratio statusPaneHeight |
    "Initialize local variables."
    ratio := 2 / 5.
    statusPaneHeight := 25.

    "Initialize GrepBrowser instance variables."
    scrollLine isNil ifTrue:[scrollLine := 5].
    searchFile isNil ifTrue:[searchFile := ''].
    textFileName := ''.             "currently selected file"
    CursorManager execute change.   "show hour glass cursor"
    self initializeGrepList.        "peform this initialization last"
    CursorManager normal change.    "show normal cursor"

    "Add subpanes, register events, map events to handlers."
    self addSubpane: (listPane := ListBox new
        owner: self;
        when: #getContents       perform: #listPaneGetContents:;
        when: #select            perform: #listPaneSelect:;
        when: #getMenu           perform: #listPaneGetMenu:;
        when: #doubleClickSelect perform: #listPanedoubleClickSelect:;
        framingBlock: ([:box|  (box leftTop) extentFromLeftTop:
            (box width @ (box height * ratio - statusPaneHeight))])).
    self addSubpane: (textPane := TextPane new
        owner: self;
                                    "NOTE #cursorMoved is a custom-
                                     defined event, not standard
                                     Smalltalk/V"
        when: #cursorMoved      perform: #textPaneCursorMoved:;
        when: #getContents      perform: #textPaneGetContents:;
        when: #save             perform: #accept:;
        framingBlock: ([:box| ((box leftTop) rightAndDown:
            (0 @ (box height * ratio - statusPaneHeight)))
                extentFromLeftTop:
                    (box width @ (box height * (1 - ratio))) ])).
    self addSubpane:(StatusPane new
        owner: self;
        height: statusPaneHeight;
        inset: 6;
        when: #getContents perform: #statusPaneGetContents:;
        framingBlock: [:box|
            (box leftBottom leftAndUp: (0 @ statusPaneHeight))
                rightBottom: box rightBottom]).
    "Set window title."
    self labelWithoutPrefix: 'Grep Browser', ': ', self fileName.
    self openWindow. "Initialization complete.  Open window."! !
