DefInt A-Z

Const cr = "Copyright 1993 ARCO Products Company. All rights reserved."

Dim drives() As String

Declare Function WNetGetConnection% Lib "User" (ByVal LocNm As String, ByVal RmtNm As String, BufSz As Integer)
Declare Function WNetAddConnection% Lib "User" (ByVal RmtNm As String, ByVal pwd As String, ByVal LocNm As String)
Declare Function WNetCancelConnection% Lib "User" (ByVal LocNm As String, ByVal Force As Integer)

Declare Function GetProfileString Lib "Kernel" (ByVal section As String, Entry As Any, ByVal DefaultVal As String, ByVal entryval As String, ByVal valsize As Integer) As Integer
Declare Function WriteProfileString Lib "Kernel" (ByVal section As String, ByVal Entry As String, entryval As Any) As Integer
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal section As String, Entry As Any, ByVal DefaultVal As String, ByVal entryval As String, ByVal valsize As Integer, ByVal inifile As String) As Integer
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal section As String, ByVal Entry As String, entryval As Any, ByVal inifile As String) As Integer

Function AppInstalled (ad As AppDescriptor)
    'See if the application described in the control file
    'is already installed for this user

    Dim rc As Integer
    Dim buf As String * 101
    Dim wininstalldate As String
    Dim appentry As String
    appentry = ad.AppName + "_upd"

    rc = GetProfileString(INSTALLDATESECTION, ByVal appentry, "", buf, 100)
    wininstalldate = Left$(buf, InStr(buf, Chr$(0)) - 1)
    If wininstalldate = ad.InstallDate Then
        AppInstalled = 1
    Else
        AppInstalled = 0
    End If

End Function

Function AttachAndMap (ald As String, apwd As String, ard As String) As Integer
    ' Map the server volume to the local drive.
    ' Assume the user is already logged onto the server.

    Dim rc As Integer
    Dim ld As String
    ErrorMsg = ""
    
    ld = UCase$(ald)

    If Len(ld) <> 2 Or Mid$(ld, 2, 1) <> ":" Or Asc(Mid$(ld, 1, 1)) < Asc(FIRSTNETDRIVE) Or Asc(Mid$(ld, 1, 1)) > Asc("Z") Then
        ErrorMsg = "Invalid local drive: " + ld
        AttachAndMap = -1
        Exit Function
    End If
    If Len(ard) = 0 Then
        ErrorMsg = "Missing remote drive"
        AttachAndMap = -2
        Exit Function
    End If

    rc = WNetAddConnection(ard, apwd, ld)
    
    AttachAndMap = rc
    If rc <> 0 Then
        ErrorMsg = "WNetAddConnection call failed, rc=" + Str$(rc)
    End If

End Function

Function CnvtFrontSlashes (aString As String) As String
    'convert all frontslashes into backslashes
    
    Dim i As Integer

    i = InStr(aString, "/")
    Do While i > 0
        Mid$(aString, i, 1) = "\"
        i = InStr(aString, "/")
    Loop

    CnvtFrontSlashes = aString

End Function

Sub DeletePreviousKW (aSection As String, aKeyword As String, aTargetini As String)
    'delete previous versions of entries the same as aKeyword
    'except for perhaps a different drive mapping in the
    'keyword itself.
        
    ' e.g.: "%drive1%\thusandsuch=whatever" is in our ctl file, and
    ' "j:\thusandsuch=whatever" was the mapped result yesterday.  we
    ' to match the "\thusandsuch" part and delete that entry
    ' from the ini section, else when we map to say h: today
    ' we will end up with 2 entries in the ini section, one
    ' for j: and one for h:.  this whole issue is the result
    ' of Microsoft Access having one such ini entry in msaccess.ini.
        
    Dim pos As Integer, pos1 As Integer, pos2 As Integer, rc As Integer
    Dim sublen
    Dim buf As String * 1001
    Dim keyword As String, targfilekw As String, targfilekwsave As String, dletter As String

    'strip the %drive.. token from the keyword parameter
    keyword = LCase$(aKeyword)
    pos = InStr(keyword, "%drive")
    Do While pos > 0
        pos1 = InStr(pos + 1, keyword, "%")
        sublen = pos1 - pos + 1
        If pos = 1 Then
            keyword = Mid$(keyword, sublen + 1, Len(keyword))
        ElseIf pos <= Len(keyword) - sublen Then
            keyword = Left$(keyword, pos - 1) + Right$(keyword, Len(keyword) - (pos + sublen - 1))
        Else
            keyword = Left$(keyword, Len(keyword) - sublen)
        End If
        
        pos = InStr(keyword, "%drive")
    Loop

    'get all entries in this section and zap any that match after we strip
    'the drive letter (e.g. h:) out
    If LCase$(aTargetini) = "win.ini" Then
        rc = GetProfileString(aSection, ByVal 0&, "", buf, 1000)
    Else
        rc = GetPrivateProfileString(aSection, ByVal 0&, "", buf, 1000, aTargetini)
    End If

    pos = 1

    Do While True

        pos1 = InStr(pos, buf, Chr$(0))
        If pos1 = pos Then Exit Do
        targfilekw = Mid$(buf, pos, pos1 - pos)
        targfilekwsave = targfilekw
        
        'strip (praying there are never any colons that don't indicate a drive)
        targfilekw = LCase$(targfilekw)
        pos2 = InStr(targfilekw, ":")
        Do While pos2 > 0
            If pos2 > 1 Then
                pos2 = pos2 - 1
                dletter = Mid$(targfilekw, pos2, 1)
                If (dletter >= "a" And dletter <= "z") Then
                    If pos2 = 1 Then
                        targfilekw = Mid$(targfilekw, 3, Len(targfilekw))
                    ElseIf pos2 <= Len(targfilekw) - 2 Then
                        targfilekw = Left$(targfilekw, pos2 - 1) + Right$(targfilekw, Len(targfilekw) - (pos2 + 1))
                    Else
                        targfilekw = Left$(targfilekw, Len(targfilekw) - 2)
                    End If
                End If
            End If
            pos2 = InStr(targfilekw, ":")
        Loop

        'compare
        If targfilekw = keyword Then
            'zap
            If LCase$(aTargetini) = "win.ini" Then
                rc = WriteProfileString(aSection, targfilekwsave, ByVal 0&)
            Else
                rc = WritePrivateProfileString(aSection, targfilekwsave, ByVal 0&, aTargetini)
            End If
        End If

        pos = pos1 + 1

    Loop

End Sub

Function DetachDrive (dr As String) As Integer
    ' detach this local drive letter from its network mapping.
    ' we have decided to force a detach even if files are open.

    rc% = WNetCancelConnection(dr, True)
    If rc% <> 0 Then
        MsgBox ("Sorry, the detach attempt failed with return code " + Str$(rc%))
    End If

    DetachDrive = rc%

End Function

Sub ErrorRtn ()
    ' generic error handler
    
    MsgBox "Error " + Str$(Err) + " -- " + Error$ + ". Setup process may fail.", 0, "LoadMan"
    End

End Sub

Function GetControlData (afile As String, ad As AppDescriptor) As Integer
    'Obtain the control data from the parm file we were
    'launched with

    Dim rc As Integer, dirflag As Integer, tempfname As String
    Dim buf As String * 1001
    
    ad.AppName = ""
    If Len(afile) = 0 Then
        GetControlData = -1
        Exit Function
    End If

    dirflag = 1
    On Error GoTo cmdfileerr
    tempfname = Dir$(afile)
    If tempfname = "" Then
        MsgBox "Could not find control file " + afile
        Exit Function
    End If
    dirflag = 0

    'store the name of the parmfile we are reading
    ad.ParmIniFile = afile

    'get the control values from the parmfile
    'get the server volumes and find drives first in case
    'some of the other values need drive substitutions
    '(i.e. if %driveN% is specified)
    
    rc = GetPrivateProfileString("control", ByVal "drive1", "", buf, 1000, afile)
    ad.ServerVol1 = Left$(buf, InStr(buf, Chr$(0)) - 1)
    If ad.ServerVol1 <> "" Then
        ad.Drive1 = MapServerVol(ad.ServerVol1)
        If ad.Drive1 = "" Then
            GetControlData = -3
            MsgBox ("A needed local drive letter was not available")
            Exit Function
        End If
    End If
    rc = GetPrivateProfileString("control", ByVal "drive2", "", buf, 1000, afile)
    ad.ServerVol2 = Left$(buf, InStr(buf, Chr$(0)) - 1)
    If ad.ServerVol2 <> "" Then
        ad.Drive2 = MapServerVol(ad.ServerVol2)
        If ad.Drive2 = "" Then
            GetControlData = -3
        End If
    End If
    rc = GetPrivateProfileString("control", ByVal "drive3", "", buf, 1000, afile)
    ad.ServerVol3 = Left$(buf, InStr(buf, Chr$(0)) - 1)
    If ad.ServerVol3 <> "" Then
        ad.Drive3 = MapServerVol(ad.ServerVol3)
        If ad.Drive3 = "" Then
            GetControlData = -3
        End If
    End If
    rc = GetPrivateProfileString("control", ByVal "drive4", "", buf, 1000, afile)
    ad.ServerVol4 = Left$(buf, InStr(buf, Chr$(0)) - 1)
    If ad.ServerVol4 <> "" Then
        ad.Drive4 = MapServerVol(ad.ServerVol4)
        If ad.Drive4 = "" Then
            GetControlData = -3
        End If
    End If

    'get the rest of the control values
    rc = GetPrivateProfileString("control", ByVal "installdate", "", buf, 1000, afile)
    ad.InstallDate = Left$(buf, InStr(buf, Chr$(0)) - 1)
    rc = GetPrivateProfileString("control", ByVal "appname", "", buf, 1000, afile)
    ad.AppName = Left$(buf, InStr(buf, Chr$(0)) - 1)
    rc = GetPrivateProfileString("control", ByVal "appdrive", "", buf, 1000, afile)
    ad.AppDrive = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.AppDrive, ad
    rc = GetPrivateProfileString("control", ByVal "apppath", "", buf, 1000, afile)
    ad.AppPath = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.AppPath, ad
    If Right$(ad.AppPath, 1) <> "\" Then ad.AppPath = ad.AppPath + "\"
    rc = GetPrivateProfileString("control", ByVal "copyfiles", "", buf, 1000, afile)
    ad.CopyFiles = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.CopyFiles, ad
    rc = GetPrivateProfileString("control", ByVal "loadcommand", "", buf, 1000, afile)
    ad.LoadCommand = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.LoadCommand, ad
    rc = GetPrivateProfileString("control", ByVal "wininisections", "", buf, 1000, afile)
    ad.WinIniSections = Left$(buf, InStr(buf, Chr$(0)) - 1)
    
    rc = GetPrivateProfileString("control", ByVal "privateini1name", "", buf, 1000, afile)
    ad.PrivateIni1Name = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.PrivateIni1Name, ad
    rc = GetPrivateProfileString("control", ByVal "privateini1sections", "", buf, 1000, afile)
    ad.PrivateIni1Sections = Left$(buf, InStr(buf, Chr$(0)) - 1)
    
    rc = GetPrivateProfileString("control", ByVal "privateini2name", "", buf, 1000, afile)
    ad.PrivateIni2Name = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.PrivateIni2Name, ad
    rc = GetPrivateProfileString("control", ByVal "privateini2sections", "", buf, 1000, afile)
    ad.PrivateIni2Sections = Left$(buf, InStr(buf, Chr$(0)) - 1)

    rc = GetPrivateProfileString("control", ByVal "privateini3name", "", buf, 1000, afile)
    ad.PrivateIni3Name = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.PrivateIni3Name, ad
    rc = GetPrivateProfileString("control", ByVal "privateini3sections", "", buf, 1000, afile)
    ad.PrivateIni3Sections = Left$(buf, InStr(buf, Chr$(0)) - 1)

    rc = GetPrivateProfileString("control", ByVal "privateini4name", "", buf, 1000, afile)
    ad.PrivateIni4Name = Left$(buf, InStr(buf, Chr$(0)) - 1)
    SubstituteDrive ad.PrivateIni4Name, ad
    rc = GetPrivateProfileString("control", ByVal "privateini4sections", "", buf, 1000, afile)
    ad.PrivateIni4Sections = Left$(buf, InStr(buf, Chr$(0)) - 1)
    
    GetControlData = 0
    Exit Function

cmdfileerr:
    'have mercy when there's an invalid control file
    If dirflag <> 0 Then
        MsgBox "Error " + LTrim$(Str$(Err)) + " (" + Error$ + ")" + " on control file " + afile
    Else
        ErrorRtn
    End If
    Exit Function

End Function

Function GetDriveDlg (items() As String, numitems As Integer) As String

    Load LdManDr
    
    Dim i As Integer

    For i = 0 To numitems - 1
        If Len(items(i)) Then
            LdManDr.List1.AddItem items(i)
        End If
    Next i
    
    LdManDr.Show 1

    GetDriveDlg = ReturnedStr

End Function

Function GetFileName (aPath As String) As String
    'extract the filename from a full pathname

    Dim i As Integer, c As String

    For i = Len(aPath) To 1 Step -1
        c = Mid$(aPath, i, 1)
        If c = "\" Or c = ":" Then
            GetFileName = RTrim$(Mid$(aPath, i + 1, 12))
            Exit Function
        End If
    Next

    GetFileName = aPath

End Function

Function GetLocalDrive (aServerVol As String) As String
    'Find out if we are already mapped to the needed volume.
    'If so, return "X:CONNECTED" where X is the local drive;
    'if not, find an unused local drive letter we can use
    'to attach to the server volume and return "X:".
    
    Dim rc As Integer, i As Integer
    Dim RmtNm As String * 151, d As String
    Dim n As Integer
    Dim ucservervol As String, temp As String, result As String
    ErrorMsg = ""
    'size the Drives string array based on possible drive
    'letters we could ask the user to detach if we cannot
    'find a free one.
    ReDim drives(Len(CANDIDATEDRIVES))

    d = FIRSTNETDRIVE
    n = 0
    result = ""
    ucservervol = UCase$(aServerVol)
    ucservervol = CnvtFrontSlashes(ucservervol)

    Do While Asc(d) <= Asc("Z")
        rc = WNetGetConnection(d + ":", RmtNm, 150)
        If rc = WN_NOT_CONNECTED And result = "" Then
            result = d + ":"
        Else
            temp = UCase$(Left$(RmtNm, InStr(RmtNm, Chr$(0)) - 1))
            temp = CnvtFrontSlashes(temp)
            If ucservervol <> "" And temp = ucservervol Then
                result = d + ":CONNECTED"
                Exit Do
            End If
        End If
        ' build a list of candidate detachees just in case
        If result = "" And InStr(CANDIDATEDRIVES, d) Then
        'If InStr(CANDIDATEDRIVES, d) Then
            drives(n) = d + ":" + Space$(4) + UCase$(Left$(RmtNm, InStr(RmtNm, Chr$(0)) - 1))
            n = n + 1
        End If
        d = Chr$(Asc(d) + 1)
    Loop

    If result = "" And Len(CANDIDATEDRIVES) > 0 Then
    'If Len(CANDIDATEDRIVES) > 0 Then
        ' there are no free local drives to map to, so ask
        ' the user to free up one in the CANDIDATEDRIVES list.
        drive$ = GetDriveDlg(drives(), Len(CANDIDATEDRIVES))
        drive$ = Left$(drive$, 2)
        rc% = DetachDrive(drive$)
        If rc% = 0 Then result = drive$
    End If
    
    GetLocalDrive = result

End Function

Sub InstallApp (ad As AppDescriptor)
    'Install whatever is needed for the user to run the
    'application

    Dim rc As Integer

    ' copy each file in the CopyFiles string
    Dim parmstr As String, src As String, dest As String
    parmstr = ad.CopyFiles + ";"
    Dim pos As Integer, pos1 As Integer
    pos = 1
    Do While Len(parmstr) > 1
        pos = InStr(parmstr, ">")
        If pos > 0 Then
            src = Left$(parmstr, pos - 1)
            pos1 = InStr(pos, parmstr, ";")
            dest = Mid$(parmstr, pos + 1, pos1 - 1 - pos)
            Dim nooverlay As Integer
            nooverlay = InStr(dest, ",nooverlay")
            If nooverlay > 0 Then
                dest = Left$(dest, nooverlay - 1)
            End If
            If Dir$(dest) = "" Or nooverlay = 0 Then
                FileCopy src, dest
            End If
        Else
            pos1 = InStr(parmstr, ";")
        End If
        If pos1 = Len(parmstr) Then
            parmstr = ""
        Else
            parmstr = Right$(parmstr, Len(parmstr) - pos1)
        End If
    Loop

    ' note the install date in WIN.INI
    Dim updstr As String
    updstr = LCase$(ad.AppName) + "_upd"
    rc = WriteProfileString(INSTALLDATESECTION, updstr, ByVal ad.InstallDate)

End Sub

Sub Main ()

    Dim ad As AppDescriptor
    
    On Error GoTo ErrorLabel

    If Command$ = "" Then
        MsgBox ("Control file was not passed to LoadMan")
        End
    End If
    
    SetNotice "Reading control file..."
    
    rc% = GetControlData(Command$, ad)
    If rc% <> 0 Then End
    
    ' install the app if necessary
    If AppInstalled(ad) = 0 Then
        SetNotice "Installing the application..."
        InstallApp ad
    End If
    
    ProcessIniFiles ad

    SetNotice "Loading application..."

    ' run the app
    ChDrive ad.AppDrive
    ChDir ad.AppPath
    rc% = Shell(ad.LoadCommand, 3)

    LdManPr.Hide

    End
    Exit Sub

ErrorLabel:
    ErrorRtn

End Sub

Function MapServerVol (aServerVol As String) As String
    ' map aservervol to a local drive, or find out if it is
    ' already mapped
    
    Dim d As String

    d = GetLocalDrive(aServerVol)
    
    If InStr(d, "CONNECTED") > 0 Then
        ' already mapped to that volume
        d = Left$(d, 2)
    Else
        If d <> "" Then
            ' not already mapped, do it now
            rc% = AttachAndMap(d, "", aServerVol)
        End If
    End If

    MapServerVol = d

End Function

Sub ProcessIniFiles (ad As AppDescriptor)
    ' each time we fire up, we have to redo the ini file
    ' entries because the drive mappings may be different
    ' from what they were last time and the drive letters
    ' are referred to in various entries.
    
    ' write the win.ini stuff if any
    If ad.WinIniSections <> "" Then
        ProcessIniSections ad.WinIniSections, ad, "WIN.INI"
    End If

    ' write the privateini1 stuff if any
    If ad.PrivateIni1Name <> "" And ad.PrivateIni1Sections <> "" Then
        ProcessIniSections ad.PrivateIni1Sections, ad, ad.PrivateIni1Name
    End If

    ' write the privateini2 stuff if any
    If ad.PrivateIni2Name <> "" And ad.PrivateIni2Sections <> "" Then
        ProcessIniSections ad.PrivateIni2Sections, ad, ad.PrivateIni2Name
    End If

    ' write the privateini3 stuff if any
    If ad.PrivateIni3Name <> "" And ad.PrivateIni3Sections <> "" Then
        ProcessIniSections ad.PrivateIni3Sections, ad, ad.PrivateIni3Name
    End If

    ' write the privateini4 stuff if any
    If ad.PrivateIni4Name <> "" And ad.PrivateIni4Sections <> "" Then
        ProcessIniSections ad.PrivateIni4Sections, ad, ad.PrivateIni4Name
    End If

End Sub

Sub ProcessIniSections (inisections As String, ad As AppDescriptor, targetini As String)
    ' process parmfile sections for a particular .ini file
    
    Dim parmstr As String, section As String
    Dim pos As Integer

    If inisections <> "" Then
        parmstr = inisections + ";"
        pos = 1
        Do While parmstr <> ""
            pos = InStr(parmstr, ";")
            section = Left$(parmstr, pos - 1)
            If Len(section) > 0 Then WriteIniSection section, ad, targetini
            If pos = Len(parmstr) Then
                parmstr = ""
            Else
                parmstr = Right$(parmstr, Len(parmstr) - pos)
            End If
        Loop
    End If

End Sub

Sub SetNotice (s As String)
    LdManPr.Label1.Caption = s
    If LdManPr.Visible = False Then
        LdManPr.Show
    End If
    LdManPr.Refresh
End Sub

Sub SubstituteDrive (s As String, ad As AppDescriptor)
    ' do any necessary drive substitutions

    Dim rc As Integer
    Dim tempstr As String

    tempstr = LCase$(s)
    rc = InStr(tempstr, "%drive")
    Do While rc > 0
        dletter$ = Mid$(s, rc + 6, 1)
        Select Case dletter$
            Case "1"
                s = Left$(s, rc - 1) + ad.Drive1 + Right$(s, Len(s) - (rc + 7))
            Case "2"
                s = Left$(s, rc - 1) + ad.Drive2 + Right$(s, Len(s) - (rc + 7))
            Case "3"
                s = Left$(s, rc - 1) + ad.Drive3 + Right$(s, Len(s) - (rc + 7))
            Case "4"
                s = Left$(s, rc - 1) + ad.Drive4 + Right$(s, Len(s) - (rc + 7))
        End Select
        
        tempstr = LCase$(s)
        rc = InStr(tempstr, "%drive")
    Loop

End Sub

Sub WriteIniSection (aSection As String, ad As AppDescriptor, targetini As String)
    'transfer the section from the parmfile to target .ini.
    'the section name in the control parmfile is prefixed
    'by 'win.ini.' for sections going into WIN.INI, and by
    'the name of the private .ini file for others.  this prefix must
    'be stripped off before transferring the section.

    Dim rc As Integer, pos As Integer, pos1 As Integer
    Dim buf As String * 1001
    Dim buf1 As String * 501
    Dim keyword As String, keywordsave As String, entryval As String
    Dim insection As String, outsection As String
    Dim inifile As String

    'get the output inifile name as opposed to full path
    inifile = GetFileName(targetini)

    insection = inifile + "." + aSection
    outsection = aSection
    
    ' get all the keywords in the section
    rc = GetPrivateProfileString(insection, ByVal 0&, "", buf, 1000, ad.ParmIniFile)

    pos = 1

    Do While True

        pos1 = InStr(pos, buf, Chr$(0))
        If pos1 = pos Then Exit Do
        keyword = Mid$(buf, pos, pos1 - pos)
        
        ' read the string
        rc = GetPrivateProfileString(insection, ByVal keyword, "", buf1, 500, ad.ParmIniFile)

        entryval = Left$(buf1, InStr(buf1, Chr$(0)) - 1)
        
        ' the string may have '%drive...' in it, in which case
        ' we have to add the drive we have mapped
        SubstituteDrive entryval, ad

        ' 11/19/92: the keyword may also have '%drive...' in it!
        ' (12/02/92: see WriteIniXXXX)
        ' 01/08/92: we MUST delete previous mappings of this sort
        ' (e.g. j:\yadayadayada=x but today we mapped to h:)
        If InStr(keyword, "%drive") Then
            DeletePreviousKW outsection, keyword, targetini
        End If
        keywordsave = keyword
        SubstituteDrive keyword, ad
        
        ' now write the new keyword and value with the substituted drive in it
        ' 11/24/92: distinguish between win.ini and private ini files.
        'rc = WritePrivateProfileString(outsection, keyword, ByVal entryval, targetini)
        If LCase$(targetini) = "win.ini" Then
            rc = WriteProfileString(outsection, keyword, ByVal entryval)
        Else
            rc = WritePrivateProfileString(outsection, keyword, ByVal entryval, targetini)
        End If
        
        pos = pos1 + 1

    Loop

End Sub

