VERSION 2.00
Begin Form frmMain 
   BackColor       =   &H00FFFFFF&
   Caption         =   "MAPI Development Workbench"
   ClientHeight    =   4755
   ClientLeft      =   1290
   ClientTop       =   1635
   ClientWidth     =   7245
   Height          =   5445
   Left            =   1230
   LinkTopic       =   "Form1"
   ScaleHeight     =   4755
   ScaleWidth      =   7245
   Top             =   1005
   Width           =   7365
   Begin PictureBox Picture2 
      Align           =   1  'Align Top
      Height          =   4200
      Left            =   0
      ScaleHeight     =   4170
      ScaleWidth      =   7215
      TabIndex        =   2
      Top             =   555
      Width           =   7245
      Begin Grid grdInbox 
         Cols            =   4
         FixedCols       =   0
         Height          =   4155
         Left            =   0
         TabIndex        =   3
         Top             =   0
         Width           =   7275
      End
   End
   Begin PictureBox Picture1 
      Align           =   1  'Align Top
      BackColor       =   &H00C0C0C0&
      BorderStyle     =   0  'None
      Height          =   555
      Left            =   0
      ScaleHeight     =   555
      ScaleWidth      =   7245
      TabIndex        =   0
      Top             =   0
      Width           =   7245
      Begin CommandButton cmdCompose 
         Caption         =   "&Compose"
         Height          =   465
         Left            =   90
         TabIndex        =   1
         Top             =   30
         Width           =   1155
      End
   End
   Begin Menu menuFile 
      Caption         =   "&File"
      Begin Menu menuExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu menuHelp 
      Caption         =   "&Help"
      Begin Menu menuAbout 
         Caption         =   "&About..."
      End
   End
End
Option Explicit

' Used to determine if MAPI is available at runtime
Declare Function LoadLibrary Lib "Kernel" (ByVal lpLibFileName As String) As Integer

Sub cmdCompose_Click ()
    frmCompose.Show 1
End Sub

Sub Form_Load ()
    Dim ret
    Dim s$
    Dim TABKEY$
    TABKEY$ = Chr$(9)

    On Error GoTo formLoadError

    grdInbox.Row = 0
    grdInbox.ColWidth(0) = grdInbox.Width / 3
    grdInbox.Col = 0
    grdInbox.Text = "From"
    grdInbox.ColWidth(1) = grdInbox.Width / 3
    grdInbox.Col = 1
    grdInbox.Text = "Subject"
    grdInbox.ColWidth(2) = grdInbox.Width / 3
    grdInbox.Col = 2
    grdInbox.Text = "Received"
    grdInbox.ColWidth(3) = 1
    grdInbox.Col = 3
    grdInbox.Text = ""

    ' check for MAPI support
    ret = isMAPIAvailable()
    If ret = False Then
        MsgBox "Error: MAPI support not available."
        End
    End If

    ' piggyback onto an existing mail session
    ' display dialog if no existing session
    ret = MAPILogon(0, "", "", MAPI_LOGON_UI, 0, gMAPISession)
    If ret <> SUCCESS_SUCCESS Then
        s$ = GetMAPIErrorText(ret)
        MsgBox s$
        End
        Exit Sub
    End If

    ' get messages in inbox
    getMessages
    

    Exit Sub

formLoadError:
    MsgBox "Error: " + Str$(Err)
    Exit Sub

End Sub

Sub Form_Resize ()
    grdInbox.Width = frmMain.ScaleWidth
End Sub

Sub Form_Unload (Cancel As Integer)
    Dim ret
    Dim s$

    On Error GoTo formUnloadError

    ret = MAPILogoff(gMAPISession, 0, 0, 0)
    If ret <> SUCCESS_SUCCESS Then
        s$ = GetMAPIErrorText(ret)
        MsgBox s$
    End If
    Exit Sub

formUnloadError:
    MsgBox "Error: " + Str$(Err)
    Exit Sub
End Sub

Sub getMessages ()
    Dim ret
    Dim messageID As String
    Dim i%
    Dim r
    Dim s$

    messageID = ""
    i% = 0
    Do
        ret = MAPIFindNext(gMAPISession, 0, "", messageID, MAPI_GUARANTEE_FIFO, 0, messageID)
        If ret = SUCCESS_SUCCESS Then
            ' get originator, subject and date received
            r = MAPIReadMail(gMAPISession, 0, messageID, MAPI_ENVELOPE_ONLY And MAPI_PEEK, 0, gMapiMessage, gMAPIOriginator, gMAPIRecipients(), gMAPIFiles())
            If r <> SUCCESS_SUCCESS Then
                MsgBox GetMAPIErrorText(r)
                Exit Sub
            End If
            s$ = gMAPIOriginator.name & Chr(9) + gMapiMessage.Subject & Chr(9) + gMapiMessage.datereceived & Chr(9) + messageID
            grdInbox.AddItem s$
            i% = i% + 1
        ElseIf ret <> MAPI_E_NO_MESSAGES Then
            MsgBox GetMAPIErrorText(ret)
            Exit Sub
        End If
    Loop Until ret = MAPI_E_NO_MESSAGES
    If i% <> 0 Then
        grdInbox.RemoveItem 1
    End If
End Sub

Sub grdInbox_DblClick ()
    Dim ret
    Dim messageID As String
    Dim i%
    Dim s$

    If grdInbox.SelStartRow = 0 Then
        Exit Sub
    End If
    grdInbox.Row = grdInbox.SelStartRow
    grdInbox.Col = 3
    messageID = grdInbox.Text
    i% = 0
    ret = MAPIReadMail(gMAPISession, 0, messageID, 0, 0, gMapiMessage, gMAPIOriginator, gMAPIRecipients(), gMAPIFiles())
    If ret <> SUCCESS_SUCCESS Then
        MsgBox GetMAPIErrorText(ret)
        Exit Sub
    Else
        frmRead!lblFrom.Caption = gMAPIOriginator.name
        frmRead!lblDate.Caption = gMapiMessage.datereceived
        frmRead!lblSubject.Caption = gMapiMessage.Subject
        frmRead!txtNote = gMapiMessage.NoteText
        frmRead.Show 1
        
    End If
End Sub

Function isMAPIAvailable () As Integer
    Dim ret

    isMAPIAvailable = False
    ret = LoadLibrary("mapi.dll")
    Select Case ret
        Case 0
        Case 2
        Case 3
        Case 5
        Case 6
        Case 8
        Case 10
        Case 11
        Case 12
        Case 13
        Case 14
        Case 15
        Case 16
        Case 19
        Case 20
        Case 21
        Case Else
            isMAPIAvailable = True
    End Select

    
    
End Function

Sub menuAbout_Click ()
    Dim CRLF$
    Dim TABKEY$
    Dim s$

    CRLF$ = Chr$(10) + Chr$(13)
    TABKEY$ = Chr$(9)
    s$ = "MAPI Development Workbench" + CRLF$
    s$ = s$ + "Greg Mable" + CRLF$
    s$ = s$ + "Technology Integration"
    MsgBox s$, MB_ICONINFORMATION, app.Title
End Sub

Sub menuExit_Click ()
    Form_Unload True
    End

End Sub

