///////////////////////////////////////////////////////////////////
// FILE NAME:  mftalk.cpp   TITLE: validated edit (w/voice)
//
// AUTHOR: Ken North     Resource Group, Inc.	
//                       2604B El Camino Real, #351
//                       Carlsbad, CA 92008
//
///////////////////////////////////////////////////////////////////
//	Date: Thursday, 3 June 1993.  Time: 21:30:24.
///////////////////////////////////////////////////////////////////


#include <owl.h>
#include <edit.h>
#include <listbox.h>
#include <combobox.h>
#include <bchkbox.h>
#include <checkbox.h>
#include <bradio.h>
#include <radiobut.h>
#include <scrollba.h>
#include <dialog.h>
#include <bwcc.h>
#include <mfedit.h>
#include "edittaid.h"
#include "mftalk.h"
#include "edittcls.h"


BOOL	Proofread = FALSE;

		// TEDITTALK is a child of TApplication
class TEDITTALK : public TApplication
{
public:
  TEDITTALK(LPSTR AName, HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
    : TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow) {};
    virtual void InitMainWindow();
    virtual void InitInstance();
};

void TEDITTALK::InitInstance()
{
   TApplication::InitInstance();
   HAccTable = LoadAccelerators(hInstance, "MFTALK");

}
			// Declare TMainWindow, a TWindow descendant
class TMainWindow : public TWindow
{
public:
   TMainWindow(PTWindowsObject AParent, LPSTR ATitle);
   ~TMainWindow();
   void InitTransferBuffers();
   virtual void EDIT(RTMessage Msg) = [CM_FIRST + IDM_EDIT];
   virtual void TALK(RTMessage Msg) = [CM_FIRST + IDM_TALK];
   virtual void ABOUT(RTMessage Msg) = [CM_FIRST + IDM_ABOUT];

protected:
   virtual void GetWindowClass(WNDCLASS _FAR & AWndClass);
   virtual LPSTR GetClassName();
};


	/****************************************************
	 * TMainWindow implementations: 
	 ****************************************************/

			// TMainWindow, a TWindow constructor
TMainWindow::TMainWindow(PTWindowsObject AParent, LPSTR ATitle)
                         : TWindow(AParent, ATitle)
{
   InitTransferBuffers();
   AssignMenu("MFTALK");

}

			// TMainWindow destructor
TMainWindow::~TMainWindow()
{

}

LPSTR TMainWindow::GetClassName()
{
   return "MainWindow";
}

void TMainWindow::GetWindowClass(WNDCLASS _FAR & AWndClass)
{
   TWindow::GetWindowClass(AWndClass);
   AWndClass.hbrBackground = CreateSolidBrush(0xFFFF00);

}

void TMainWindow::InitTransferBuffers()
{
};

void TMainWindow::EDIT(RTMessage)
{

		   // Modal dialog for name address info
   if (GetModule()->ExecDialog(
               new T210Dlg(this, 210, Proofread)) == IDOK )
   {

   }


}

void TMainWindow::TALK(RTMessage)
{
	BOOL	isTalkChecked;
	HMENU hMenu;

	hMenu=GetMenu(HWindow);
	if (!Proofread)
    	{
		isTalkChecked = CheckMenuItem(hMenu, IDM_TALK, MF_CHECKED);
		Proofread = TRUE;
        }
	else
    	{
		isTalkChecked = CheckMenuItem(hMenu, IDM_TALK, MF_CHECKED);
		Proofread = FALSE;
		}
}

void TMainWindow::ABOUT(RTMessage)
{


			   // About box dialog
   if (GetModule()->ExecDialog(
               new T211Dlg(this, 211)) == IDOK )
   {

   }

}


/***************************************************
 * TEDITTALKApp method implementations:
 ***************************************************/

		// Construct TEDITTALK's MainWindow of type TMainWindow
void TEDITTALK::InitMainWindow()
{
   lpTBuff210 = &TBuff210;
   lpTBuff211 = &TBuff211;
   MainWindow = new TMainWindow(NULL, Name);
}

					//  Main 
int PASCAL WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,
                   int nCmdShow)
{
   HINSTANCE hBorLibrary;

				// load Borland custom controls
   hBorLibrary = LoadLibrary("bwcc.dll");

   if((UINT)hBorLibrary <= 32)
      MessageBox(NULL, "Unable to load Borland Controls", 
			"System Error", MB_OK | MB_ICONHAND);

		// initialize MFEDIT
	MfInitMFEDIT();

   TEDITTALK EDITTALK ("Data Validation Talker", hInstance, hPrevInstance,
      lpCmdLine, nCmdShow);

   EDITTALK.Run();

   if((UINT)hBorLibrary > 32)
      FreeLibrary(hBorLibrary);

   return EDITTALK.Status;
}
