/*******************************************************
 *                                                     *
 *       NEWTEST.C - test bed for WTJDISK DLL          *
 *                                                     *
 *                 Jim Kyle - 1993                     *
 *                                                     *
 *******************************************************/
#include <windows.h>
#include "wtjdisk.h"
#include "newtest.h"

HWND hAppWnd;    // global Window handle for use as needed
HWND hChile1;
HANDLE hInst;    // global instance handle for use as needed

char szAppName[] = APP_NAME;  // ID string
char szBfr[120];
HFSTR infile = NULL;
HFSTR otfile = NULL;
DWORD position = 0L;

LRESULT WINAPI WndProc( HWND hWnd,
                        WORD msg,
                        WORD wParam,
                        long lParam )
{ long retval = 0L;           // local for return value
  switch( msg )               // dispatch the messages
    {
    case WM_CREATE:
      hChile1 = CreateWindow( "STATIC",      // class name
                              "TEXT SPACE",  // window name
                              WS_CHILD
                                | WS_VISIBLE
                                ,            // style bits
                              20,            // X
                              20,            // Y
                              450,           // width
                              20,            // height
                              hWnd,          // parent
                              -1,            // menu
                              hInst,         // instance handle
                              NULL);         // param block LP
      break;

    case WM_COMMAND:
      switch( wParam )
        {
        case DO_IT:
          if( !infile )
            infile = WTJ_Open( "newtest.c", "r" );
          WTJ_Gets( szBfr, sizeof( szBfr ), infile );
          SetWindowText( hChile1, szBfr );
	  if( otfile )
	    { int i;
	      for( i=0; i<120; i++ )
		{ if( !szBfr[i] )
		    break;
		  WTJ_Putc( szBfr[i], otfile );
		}
              WTJ_Putc( '\r', otfile );
	      WTJ_Putc( '\n', otfile );
	      WTJ_Write( szBfr, 1, lstrlen( szBfr ), otfile );
	      WTJ_Putc( '\r', otfile );
	      WTJ_Putc( '\n', otfile );
	    }
          break;

        case DO_SAVE:
          position = WTJ_Tell( infile );
          break;

        case DO_COPY:
          otfile = WTJ_Open( "copytest", "w" );
          break;

        case DO_BACK:
          WTJ_Seek( infile, position, 0 );
          break;

        case GET_OUT:
          DestroyWindow( hWnd );
          break;
        }
      break;

    case WM_DESTROY:
      WTJ_Close( infile );
      WTJ_Close( otfile );
      PostQuitMessage( 0 );
      break;

    default:                  // handles all other messages
      retval = DefWindowProc( hWnd, msg, wParam, lParam );
    }
  return retval;
}

BOOL FAR PASCAL RegApp( void )
{ WNDCLASS    wc;

  wc.style          = 0;           // plain vanilla style bits
  wc.lpfnWndProc    = (WNDPROC) WndProc;
  wc.cbClsExtra     = 0;
  wc.cbWndExtra     = 0;
  wc.hInstance      = hInst;
  wc.hIcon          = NULL;
  wc.hCursor        = NULL;        // use system defaults
  wc.hbrBackground  = COLOR_APPWORKSPACE+1;
  wc.lpszMenuName   = "Menu";
  wc.lpszClassName  = szAppName;   // initialized via macro

  return RegisterClass( &wc );
}

#pragma argsused
BOOL FAR PASCAL InitInst(LPSTR lpCmdLine, WORD nCmdShow)
{ hAppWnd = CreateWindow (szAppName,     // class name
                          szAppName,     // window name
                          WS_OVERLAPPEDWINDOW
                            | WS_CLIPCHILDREN
                            ,            // style bits
                          100,           // X
                          100,           // Y
                          600,           // width
                          200,           // height
                          NULL,          // parent
                          NULL,          // menu
                          hInst,         // instance handle
                          NULL);         // param block LP
  if (!hAppWnd)                    // CreateWindow failed
    return FALSE;
  ShowWindow (hAppWnd, nCmdShow);  // Success
  UpdateWindow (hAppWnd);
  return TRUE;
}

int PASCAL WinMain( HANDLE hInstance,     // current instance
                    HANDLE hPrevInstance, // previous instance
                    LPSTR lpszCmdLine,    // command line
                    int nCmdShow )        // min, max, or
                                          // normal
{ MSG msg;
   hInst = hInstance;    // set global instance handle
   if( !hPrevInstance )  // If this is first instance,
                         // register window class
    { if( !RegApp() )
        return 0;        // If registration failed, get out
    }
  if( !InitInst( lpszCmdLine, nCmdShow ))
    { return 0;          // If initialization failed,get out
    }
  while( GetMessage( &msg, NULL, 0, 0 ))     // run the loop
    { TranslateMessage( &msg );
      DispatchMessage( &msg );
    }
  return 0;
}
