///////////////////////////////////////////////////////////////////
// FILE NAME:  voicedit.cpp   TITLE: validated edit (w/voice)
//
// AUTHOR: Ken North     Resource Group, Inc.	
//                       2604B El Camino Real, #351
// copyright(c)1993      Carlsbad, CA 92008
///////////////////////////////////////////////////////////////////
//	Date: Thursday, 3 June 1993.  Time: 21:25:35.
///////////////////////////////////////////////////////////////////


#include <owl.h>
#include <edit.h>
#include <bwcc.h>
#include <strstrea.h>
#include <objstrm.h>
#include <string.h>

#ifndef __MONOLOG_H
#include "monolog.h"
#endif

#ifndef __VOICEDIT_H
#include "voicedit.h"
#endif


TVoiceEdit :: TVoiceEdit(PTWindowsObject AParent,
            int ResourceId, int Length, BOOL Proofread)
		: TEdit(AParent, ResourceId, Length)
{
	UseSpeech = Proofread;		/* save speech setting */
}

TVoiceEdit::~TVoiceEdit()
{

}

char* TVoiceEdit::ValidCharacters()
{
     static char LegalChars [] = 
	{
       "0123456789-"
	};

     return LegalChars;
}

BOOL TVoiceEdit::CanClose()
{
				// buffer for data to validate
	char* buf = new char [TextLen];
	GetText( (LPSTR) buf, TextLen);
	return Validate(buf);
}


int TVoiceEdit::Validate(char* ch)
{

	isDataOK = FALSE;
	char *String = ch;
	char *CheckString = ValidCharacters();

	for (; *ch; ch++) 
		{

			       // validate each character of input
		if (!strchr(CheckString, *ch) )
			{
			ErrorStatus(String);
			return FALSE;
			}
		}
				// if proofread is enabled
	if (UseSpeech)
		{
		Say((LPSTR) String);
		}

	isDataOK = TRUE;
	return TRUE;
}


void TVoiceEdit::ErrorStatus(char *ch)
{
     char MesgBuffer [100];
     ostrstream mesg(MesgBuffer, sizeof(MesgBuffer) );
     mesg << "The field '"
          << ch
          << "' contains invalid characters!"
          << ends;
     MessageBox(NULL, MesgBuffer, "Invalid Data Error",
             MB_ICONEXCLAMATION | MB_TASKMODAL | MB_OK);
}


WORD TVoiceEdit::Transfer(Pvoid DataPtr,
                     WORD TransferFlag)
{
					 // buffer for data to validate
	 char *ch = new char [TextLen];

	if (TransferFlag == TF_GETDATA)
		{
//		GetText( (LPSTR) ch, TextLen);
		if (isDataOK)
			{
			GetText( (LPSTR) DataPtr, TextLen);
			}
     }

     else if (TransferFlag == TF_SETDATA)
       SetText( (LPSTR) DataPtr);

     delete ch;
     return TextLen;
}





